IF EXISTS (SELECT
              *
           FROM
              SYSOBJECTS O, SYSUSERS U
           WHERE
              O.NAME = 'ARQDIGITAL_BLOCO9' AND
              TYPE   = 'P' 		   AND
              U.UID  = O.UID               AND
              U.NAME = USER)

DROP PROCEDURE ARQDIGITAL_BLOCO9  
GO

CREATE PROCEDURE ARQDIGITAL_BLOCO9
   @P_CONTREGA     NUMERIC,
   @P_CONTREGB     NUMERIC,
   @P_CONTREGC     NUMERIC,
   @P_CONTREGD     NUMERIC,
   @P_CONTREGE     NUMERIC,
   @P_CONTREGH     NUMERIC,
   @P_NRSEQARQMAG  VARCHAR(4000),  
   @P_RETURN       NUMERIC OUTPUT
AS
DECLARE   @V_MOVIMENT    NUMERIC;
DECLARE   @V_TOTREG9     NUMERIC;
DECLARE   @V_CONTREG9    NUMERIC;
DECLARE   @V_TOTREG      NUMERIC;

BEGIN

   /* TOTALIZAO DO BLOCO 0 */
   SET @V_CONTREG9 = ISNULL(@V_CONTREG9,0) + 1;
   INSERT INTO ARQMAGNETICO
     (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
   VALUES
     ('62'+RIGHT(REPLICATE('0',8)+RTRIM(@V_CONTREG9), 8), '|9900'+ '|' +'0000'+ '|' +'1'+ '|', @P_NRSEQARQMAG);

   SET @V_CONTREG9 = ISNULL(@V_CONTREG9,0) + 1;
   INSERT INTO ARQMAGNETICO
     (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
   VALUES
     ('62'+RIGHT(REPLICATE('0',8)+RTRIM(@V_CONTREG9), 8), '|9900'+ '|' +'0001'+ '|'+'1'+ '|', @P_NRSEQARQMAG);

   SET @V_CONTREG9 = ISNULL(@V_CONTREG9,0) + 1;
   INSERT INTO ARQMAGNETICO
     (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
   VALUES
     ('62'+RIGHT(REPLICATE('0',8)+RTRIM(@V_CONTREG9), 8), '|9900'+ '|' +'0005'+ '|' +'1'+ '|', @P_NRSEQARQMAG);

   SET @V_CONTREG9 = ISNULL(@V_CONTREG9,0) + 1;
   INSERT INTO ARQMAGNETICO
     (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
   VALUES
     ('62'+RIGHT(REPLICATE('0',8)+RTRIM(@V_CONTREG9), 8), '|9900'+ '|' +'0100'+ '|' +'1'+ '|', @P_NRSEQARQMAG);

   SET @V_CONTREG9 = ISNULL(@V_CONTREG9,0) + 1;
   INSERT INTO ARQMAGNETICO
     (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
   VALUES
     ('62'+RIGHT(REPLICATE('0',8)+RTRIM(@V_CONTREG9), 8), '|9900'+ '|' +'0125'+ '|' +'1'+ '|', @P_NRSEQARQMAG);

   /* totalizao do BLOCO 0150*/
   SET @V_CONTREG9 = ISNULL(@V_CONTREG9,0) + 1;

   SELECT @V_TOTREG = COUNT(*)	
   FROM ARQMAGNETICO
   WHERE SUBSTRING(DSREGARQMAG,2,4) = '0150';

   INSERT INTO ARQMAGNETICO
     (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
   VALUES
     ('62'+RIGHT(REPLICATE('0',8)+RTRIM(@V_CONTREG9),8), '|9900'+ '|' +'0150'+ '|' + CONVERT(VARCHAR, @V_TOTREG) + '|', @P_NRSEQARQMAG);

   /* totalizao do BLOCO 0175 */
   SET @V_TOTREG = 0;
   SET @V_CONTREG9 = ISNULL(@V_CONTREG9,0) + 1;

   SELECT @V_TOTREG = COUNT(*)
   FROM ARQMAGNETICO
   WHERE SUBSTRING(DSREGARQMAG,2,4) = '0175';

   INSERT INTO ARQMAGNETICO
     (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
   VALUES
     ('62'+RIGHT(REPLICATE('0',8)+RTRIM(@V_CONTREG9),8), '|9900'+ '|' +'0175'+ '|' + CONVERT(VARCHAR, @V_TOTREG) + '|', @P_NRSEQARQMAG);

   /* totalizao do BLOCO 0200 */
   SET @V_TOTREG = 0;
   SET @V_CONTREG9 = ISNULL(@V_CONTREG9,0) + 1;

   SELECT @V_TOTREG = COUNT(*)
   FROM ARQMAGNETICO
   WHERE SUBSTRING(DSREGARQMAG,2,4) = '0200';

   INSERT INTO ARQMAGNETICO
     (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
   VALUES
     ('62'+RIGHT(REPLICATE('0',8)+RTRIM(@V_CONTREG9),8), '|9900'+ '|' +'0200'+ '|' + CONVERT(VARCHAR, @V_TOTREG)+ '|', @P_NRSEQARQMAG);

   /* totalizao do BLOCO 0400 */
   SET @V_TOTREG = 0;
   SET @V_CONTREG9 = ISNULL(@V_CONTREG9,0) + 1;

   SELECT @V_TOTREG = COUNT(*)
   FROM ARQMAGNETICO
   WHERE SUBSTRING(DSREGARQMAG,2,4) = '0400';

   INSERT INTO ARQMAGNETICO
     (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
   VALUES
     ('62'+RIGHT(REPLICATE('0',8)+RTRIM(@V_CONTREG9),8), '|9900'+ '|' +'0400'+ '|' + CONVERT(VARCHAR, @V_TOTREG) + '|', @P_NRSEQARQMAG);

   /* TOTALIZAO DO BLOCO 0990 */
   SET @V_CONTREG9 = ISNULL(@V_CONTREG9,0) + 1;
   INSERT INTO ARQMAGNETICO
     (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
   VALUES
     ('62'+RIGHT(REPLICATE('0',8)+RTRIM(@V_CONTREG9),8), '|9900'+ '|' +'0990'+ '|' +'1'+ '|', @P_NRSEQARQMAG);


   /* TOTALIZAO DO BLOCO A001 */
   SET @V_CONTREG9 = ISNULL(@V_CONTREG9,0) + 1;
   INSERT INTO ARQMAGNETICO
     (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
   VALUES
     ('62'+RIGHT(REPLICATE('0',8)+RTRIM(@V_CONTREG9),8), '|9900'+ '|' +'A001'+ '|' +'1'+ '|', @P_NRSEQARQMAG);

   /* TOTALIZAO DO BLOCO A990 */
   SET @V_CONTREG9 = ISNULL(@V_CONTREG9,0) + 1;
   INSERT INTO ARQMAGNETICO
     (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
   VALUES
     ('62'+RIGHT(REPLICATE('0',8)+RTRIM(@V_CONTREG9),8), '|9900'+ '|' +'A990'+ '|' +'1'+ '|', @P_NRSEQARQMAG);

   /* TOTALIZAO DO BLOCO B001 */
   SET @V_CONTREG9 = ISNULL(@V_CONTREG9,0) + 1;
   INSERT INTO ARQMAGNETICO
     (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
   VALUES
     ('62'+RIGHT(REPLICATE('0',8)+RTRIM(@V_CONTREG9),8), '|9900'+ '|' +'B001'+ '|' +'1'+ '|', @P_NRSEQARQMAG);

   /* TOTALIZAO DO BLOCO B400 */
   SET @V_TOTREG = 0;
   SET @V_CONTREG9 = ISNULL(@V_CONTREG9,0) + 1;
   SELECT @V_TOTREG = COUNT(*)
   FROM ARQMAGNETICO 
   WHERE SUBSTRING(DSREGARQMAG,2,4) = 'B400';

   INSERT INTO ARQMAGNETICO
     (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
   VALUES
     ('62'+RIGHT(REPLICATE('0',8)+RTRIM(@V_CONTREG9),8), '|9900'+ '|' +'B400'+ '|' + CONVERT(VARCHAR, @V_TOTREG) + '|', @P_NRSEQARQMAG);


   /* TOTALIZAO DO BLOCO B410 */
   SET @V_TOTREG = 0;
   SET @V_CONTREG9 = ISNULL(@V_CONTREG9,0) + 1;
   SELECT @V_TOTREG = COUNT(*)
   FROM ARQMAGNETICO
   WHERE SUBSTRING(DSREGARQMAG,2,4) = 'B410';

   INSERT INTO ARQMAGNETICO
     (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
   VALUES
     ('62'+RIGHT(REPLICATE('0',8)+RTRIM(@V_CONTREG9),8), '|9900'+ '|' +'B410'+ '|' + CONVERT(VARCHAR, @V_TOTREG) + '|', @P_NRSEQARQMAG);


   /* TOTALIZAO DO BLOCO B990 */
   SET @V_CONTREG9 = ISNULL(@V_CONTREG9,0)  + 1;
   INSERT INTO ARQMAGNETICO
     (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
   VALUES
     ('62'+RIGHT(REPLICATE('0',8)+RTRIM(@V_CONTREG9),8), '|9900'+ '|' +'B990'+ '|' +'1'+ '|', @P_NRSEQARQMAG);


   /* TOTALIZAO DO BLOCO C001 */
   SET @V_CONTREG9 = ISNULL(@V_CONTREG9,0)  + 1;
   INSERT INTO ARQMAGNETICO
     (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
   VALUES
     ('62'+RIGHT(REPLICATE('0',8)+RTRIM(@V_CONTREG9),8), '|9900'+ '|' +'C001'+ '|' +'1'+ '|', @P_NRSEQARQMAG);

   /* TOTALIZAO DO BLOCO C020 */
   SET @V_TOTREG = 0;
   SET @V_CONTREG9 = ISNULL(@V_CONTREG9,0) + 1;
   SELECT @V_TOTREG = COUNT(*)
   FROM ARQMAGNETICO
   WHERE SUBSTRING(DSREGARQMAG,2,4) = 'C020';

   IF @V_TOTREG IS NOT NULL BEGIN
      INSERT INTO ARQMAGNETICO
        (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
      VALUES
        ('62'+RIGHT(REPLICATE('0',8)+RTRIM(@V_CONTREG9),8), '|9900'+ '|' +'C020'+ '|'+ CONVERT(VARCHAR, @V_TOTREG) + '|', @P_NRSEQARQMAG);
   END;

   /* TOTALIZAO DO BLOCO C050 */
   SET @V_TOTREG = 0;
   SET @V_CONTREG9 = ISNULL(@V_CONTREG9,0) + 1;
   SELECT @V_TOTREG = COUNT(*)
   FROM ARQMAGNETICO
   WHERE SUBSTRING(DSREGARQMAG,2,4) = 'C050';

   IF @V_TOTREG IS NOT NULL BEGIN
      INSERT INTO ARQMAGNETICO
        (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
      VALUES
        ('62'+RIGHT(REPLICATE('0',8)+RTRIM(@V_CONTREG9),8), '|9900'+ '|' +'C050'+ '|' + CONVERT(VARCHAR, @V_TOTREG) + '|', @P_NRSEQARQMAG);
   END;

   /* TOTALIZAO DO BLOCO C250 */
   SET @V_TOTREG = 0;
   SET @V_CONTREG9 = ISNULL(@V_CONTREG9,0) + 1;
   SELECT @V_TOTREG = COUNT(*)
   FROM ARQMAGNETICO
   WHERE SUBSTRING(DSREGARQMAG,2,4) = 'C250';

   IF @V_TOTREG IS NOT NULL BEGIN
      INSERT INTO ARQMAGNETICO
        (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
      VALUES
        ('62'+RIGHT(REPLICATE('0',8)+RTRIM(@V_CONTREG9),8), '|9900'+ '|' +'C250'+ '|' + CONVERT(VARCHAR, @V_TOTREG)+ '|', @P_NRSEQARQMAG);
   END;

   /* TOTALIZAO DO BLOCO C300 */
   SET @V_TOTREG = 0;
   SET @V_CONTREG9 = ISNULL(@V_CONTREG9,0) + 1;
   SELECT @V_TOTREG = COUNT(*)
   FROM ARQMAGNETICO
   WHERE SUBSTRING(DSREGARQMAG,2,4) = 'C300';

   IF @V_TOTREG IS NOT NULL BEGIN
      INSERT INTO ARQMAGNETICO
        (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
      VALUES
        ('62'+RIGHT(REPLICATE('0',8)+RTRIM(@V_CONTREG9),8), '|9900'+ '|' +'C300'+ '|' + CONVERT(VARCHAR, @V_TOTREG) + '|',@P_NRSEQARQMAG);
   END;

   /* TOTALIZAO DO BLOCO C550 */
   SET @V_TOTREG = 0;
   SET @V_CONTREG9 = ISNULL(@V_CONTREG9,0) + 1;
   SELECT @V_TOTREG = COUNT(*)
   FROM ARQMAGNETICO
   WHERE SUBSTRING(DSREGARQMAG,2,4) = 'C550';

   IF @V_TOTREG IS NOT NULL BEGIN
      INSERT INTO ARQMAGNETICO
        (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
      VALUES
        ('62'+RIGHT(REPLICATE('0',8)+RTRIM(@V_CONTREG9),8), '|9900'+ '|' +'C550'+ '|'+ CONVERT(VARCHAR, @V_TOTREG) + '|',@P_NRSEQARQMAG);
   END;

   /* TOTALIZAO DO BLOCO C555 */
   SET @V_TOTREG = 0;
   SET @V_CONTREG9 = ISNULL(@V_CONTREG9,0) + 1;
   SELECT @V_TOTREG = COUNT(*)
   FROM ARQMAGNETICO
   WHERE SUBSTRING(DSREGARQMAG,2,4) = 'C555';

   IF @V_TOTREG IS NOT NULL BEGIN
      INSERT INTO ARQMAGNETICO
        (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
      VALUES
        ('62'+RIGHT(REPLICATE('0',8)+RTRIM(@V_CONTREG9),8), '|9900'+ '|' +'C555'+ '|' + CONVERT(VARCHAR, @V_TOTREG) + '|',@P_NRSEQARQMAG);
   END;

   /* TOTALIZAO DO BLOCO C580 */
   SET @V_TOTREG = 0;
   SET @V_CONTREG9 = ISNULL(@V_CONTREG9,0) + 1;
   SELECT @V_TOTREG = COUNT(*)
   FROM ARQMAGNETICO
   WHERE SUBSTRING(DSREGARQMAG,2,4) = 'C580';

   IF @V_TOTREG IS NOT NULL BEGIN
      INSERT INTO ARQMAGNETICO
        (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
      VALUES
        ('62'+RIGHT(REPLICATE('0',8)+RTRIM(@V_CONTREG9),8), '|9900'+ '|' +'C580'+ '|' + CONVERT(VARCHAR, @V_TOTREG) + '|',@P_NRSEQARQMAG);
   END;

   /* TOTALIZAO DO BLOCO C990 */
   SET @V_CONTREG9 = ISNULL(@V_CONTREG9,0) + 1;
   INSERT INTO ARQMAGNETICO
     (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
   VALUES
     ('62'+RIGHT(REPLICATE('0',8)+RTRIM(@V_CONTREG9),8), '|9900'+ '|' +'C990'+ '|' +'1'+ '|',@P_NRSEQARQMAG);


   /* TOTALIZAO DO BLOCO D001 */
   SET @V_CONTREG9 = ISNULL(@V_CONTREG9,0) + 1;
   INSERT INTO ARQMAGNETICO
     (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
   VALUES
     ('62'+RIGHT(REPLICATE('0',8)+RTRIM(@V_CONTREG9),8), '|9900'+ '|' +'D001'+ '|' +'1'+ '|',@P_NRSEQARQMAG);

   /* TOTALIZAO DO BLOCO D990 */
   SET @V_CONTREG9 = ISNULL(@V_CONTREG9,0) + 1;
   INSERT INTO ARQMAGNETICO
     (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
   VALUES
     ('62'+RIGHT(REPLICATE('0',8)+RTRIM(@V_CONTREG9),8), '|9900'+ '|' +'D990'+ '|' +'1'+ '|',@P_NRSEQARQMAG);

   /* TOTALIZAO DO BLOCO E001 */
   SET @V_CONTREG9 = ISNULL(@V_CONTREG9,0) + 1;
   INSERT INTO ARQMAGNETICO
     (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
   VALUES
     ('62'+RIGHT(REPLICATE('0',8)+RTRIM(@V_CONTREG9),8), '|9900'+ '|' +'E001'+ '|' +'1'+ '|',@P_NRSEQARQMAG);

   /* TOTALIZAO DO BLOCO E020 */
   SET @V_TOTREG = 0;
   SET @V_CONTREG9 = ISNULL(@V_CONTREG9,0) + 1;
   SELECT @V_TOTREG = COUNT(*)
   FROM ARQMAGNETICO
   WHERE SUBSTRING(DSREGARQMAG,2,4) = 'E020';

   IF @V_TOTREG IS NOT NULL BEGIN
      INSERT INTO ARQMAGNETICO
        (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
      VALUES
        ('62'+RIGHT(REPLICATE('0',8)+RTRIM(@V_CONTREG9), 8), '|9900'+ '|' +'E020'+ '|' + CONVERT(VARCHAR, @V_TOTREG) + '|',@P_NRSEQARQMAG);
   END;

   /* TOTALIZAO DO BLOCO E025 */
   SET @V_TOTREG = 0;
   SET @V_CONTREG9 = ISNULL(@V_CONTREG9,0) + 1;
   SELECT @V_TOTREG = COUNT(*)
   FROM ARQMAGNETICO
   WHERE SUBSTRING(DSREGARQMAG,2,4) = 'E025';

   IF @V_TOTREG IS NOT NULL BEGIN
      INSERT INTO ARQMAGNETICO
        (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
      VALUES
        ('62'+RIGHT(REPLICATE('0', 8)+RTRIM(@V_CONTREG9), 8), '|9900'+ '|' +'E025'+ '|' + CONVERT(VARCHAR, @V_TOTREG) + '|',@P_NRSEQARQMAG);
   END;

   /* TOTALIZAO DO BLOCO E050 */
   SET @V_TOTREG = 0;
   SET @V_CONTREG9 = ISNULL(@V_CONTREG9,0) + 1;
   SELECT @V_TOTREG = COUNT(*)
   FROM ARQMAGNETICO
   WHERE SUBSTRING(DSREGARQMAG,2,4) = 'E050';

   IF @V_TOTREG IS NOT NULL BEGIN
      INSERT INTO ARQMAGNETICO
        (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
      VALUES
        ('62'+RIGHT(REPLICATE('0', 8)+ RTRIM(@V_CONTREG9), 8), '|9900'+ '|' +'E050'+ '|' + CONVERT(VARCHAR, @V_TOTREG) + '|',@P_NRSEQARQMAG);
   END;

   /* TOTALIZAO DO BLOCO E055 */
   SET @V_TOTREG = 0;
   SET @V_CONTREG9 = ISNULL(@V_CONTREG9,0) + 1;
   SELECT @V_TOTREG = COUNT(*)
   FROM ARQMAGNETICO
   WHERE SUBSTRING(DSREGARQMAG,2,4) = 'E055';

   IF @V_TOTREG IS NOT NULL BEGIN
      INSERT INTO ARQMAGNETICO
        (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
      VALUES
        ('62'+RIGHT(REPLICATE('0', 8)+RTRIM(@V_CONTREG9), 8), '|9900'+ '|' +'E055'+ '|' + CONVERT(VARCHAR, @V_TOTREG) + '|',@P_NRSEQARQMAG);
   END;

   /* TOTALIZAO DO BLOCO E300 */
   SET @V_TOTREG = 0;
   SET @V_CONTREG9 = ISNULL(@V_CONTREG9,0) + 1;
   SELECT @V_TOTREG = COUNT(*)
   FROM ARQMAGNETICO
   WHERE SUBSTRING(DSREGARQMAG,2,4) = 'E300';

   IF @V_TOTREG IS NOT NULL BEGIN
      INSERT INTO ARQMAGNETICO
        (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
      VALUES
        ('62'+RIGHT(REPLICATE('0', 8)+RTRIM(@V_CONTREG9), 8), '|9900'+ '|' +'E300'+ '|' + CONVERT(VARCHAR, @V_TOTREG) + '|',@P_NRSEQARQMAG);
   END;

   /* TOTALIZAO DO BLOCO E310 */
   SET @V_TOTREG = 0;
   SET @V_CONTREG9 = ISNULL(@V_CONTREG9,0) + 1;
   SELECT @V_TOTREG = COUNT(*)
   FROM ARQMAGNETICO
   WHERE SUBSTRING(DSREGARQMAG,2,4) = 'E310';

   IF @V_TOTREG IS NOT NULL BEGIN
      INSERT INTO ARQMAGNETICO
        (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
      VALUES
        ('62'+RIGHT(REPLICATE('0',8)+RTRIM(@V_CONTREG9), 8), '|9900'+ '|' +'E310'+ '|' + CONVERT(VARCHAR, @V_TOTREG) + '|',@P_NRSEQARQMAG);
   END;

   /* TOTALIZAO DO BLOCO E320 */
   SET @V_TOTREG = 0;
   SET @V_CONTREG9 = ISNULL(@V_CONTREG9,0) + 1;
   SELECT @V_TOTREG = COUNT(*)
   FROM ARQMAGNETICO
   WHERE SUBSTRING(DSREGARQMAG,2,4) = 'E320';

   IF @V_TOTREG IS NOT NULL BEGIN
      INSERT INTO ARQMAGNETICO
        (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
      VALUES
        ('62'+RIGHT(REPLICATE('0', 8)+ RTRIM(@V_CONTREG9), 8), '|9900'+ '|' +'E320'+ '|' + CONVERT(VARCHAR, @V_TOTREG) + '|',@P_NRSEQARQMAG);
   END;

   /* TOTALIZAO DO BLOCO E330 */
   SET @V_TOTREG = 0;
   SET @V_CONTREG9 = ISNULL(@V_CONTREG9,0) + 1;
   SELECT @V_TOTREG = COUNT(*)
   FROM ARQMAGNETICO
   WHERE SUBSTRING(DSREGARQMAG,2,4) = 'E330';

   IF @V_TOTREG IS NOT NULL BEGIN
      INSERT INTO ARQMAGNETICO
        (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
      VALUES
        ('62'+RIGHT(REPLICATE('0', 8)+RTRIM(@V_CONTREG9), 8), '|9900'+ '|' +'E330'+ '|' + CONVERT(VARCHAR, @V_TOTREG) + '|',@P_NRSEQARQMAG);
   END;

   /* TOTALIZAO DO BLOCO E360 */
   SET @V_TOTREG = 0;
   SET @V_CONTREG9 = ISNULL(@V_CONTREG9,0) + 1;
   SELECT @V_TOTREG = COUNT(*)
   FROM ARQMAGNETICO
   WHERE SUBSTRING(DSREGARQMAG,2,4) = 'E360';

   IF @V_TOTREG IS NOT NULL BEGIN
      INSERT INTO ARQMAGNETICO
        (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
      VALUES
        ('62'+RIGHT(REPLICATE('0', 8)+ RTRIM(@V_CONTREG9), 8), '|9900'+ '|' +'E360'+ '|' + CONVERT(VARCHAR, @V_TOTREG) + '|',@P_NRSEQARQMAG);
   END;

   /* TOTALIZAO DO BLOCO E500 */
   SET @V_TOTREG = 0;
   SET @V_CONTREG9 = ISNULL (@V_CONTREG9,0) + 1;
   SELECT @V_TOTREG = COUNT(*)
   FROM ARQMAGNETICO
   WHERE SUBSTRING(DSREGARQMAG,2,4) = 'E500';

   IF @V_TOTREG IS NOT NULL BEGIN
      INSERT INTO ARQMAGNETICO
        (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
      VALUES
        ('62'+RIGHT(REPLICATE('0', 8)+RTRIM(@V_CONTREG9), 8), '|9900'+ '|' +'E500'+ '|' + CONVERT(VARCHAR, @V_TOTREG) + '|',@P_NRSEQARQMAG);
   END;

   /* TOTALIZAO DO BLOCO E510 */
   SET @V_TOTREG = 0;
   SET @V_CONTREG9 = ISNULL(@V_CONTREG9,0) + 1;
   SELECT @V_TOTREG = COUNT(*)
   FROM ARQMAGNETICO
   WHERE SUBSTRING(DSREGARQMAG,2,4) = 'E510';

   IF @V_TOTREG IS NOT NULL BEGIN
      INSERT INTO ARQMAGNETICO
        (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
      VALUES
        ('62'+RIGHT(REPLICATE('0', 8)+ RTRIM(@V_CONTREG9), 8),'|9900'+ '|'+'E510'  + '|' + CONVERT(VARCHAR, @V_TOTREG) + '|',@P_NRSEQARQMAG);
   END;

   /* TOTALIZAO DO BLOCO E530 */
   SET @V_TOTREG = 0;
   SET @V_CONTREG9 = ISNULL(@V_CONTREG9,0) + 1;
   SELECT @V_TOTREG = COUNT(*)
   FROM ARQMAGNETICO
   WHERE SUBSTRING(DSREGARQMAG,2,4) = 'E530';

   IF @V_TOTREG IS NOT NULL BEGIN
      INSERT INTO ARQMAGNETICO
        (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
      VALUES
        ('62'+RIGHT(REPLICATE('0', 8)+RTRIM(@V_CONTREG9), 8), '|9900'+ '|' +'E530'+ '|' + CONVERT(VARCHAR, @V_TOTREG) + '|',@P_NRSEQARQMAG);
  END;

   /* TOTALIZAO DO BLOCO E990 */
   SET @V_CONTREG9 = ISNULL(@V_CONTREG9,0) + 1;
   INSERT INTO ARQMAGNETICO
     (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
   VALUES
     ('62'+RIGHT(REPLICATE('0',8)+RTRIM(@V_CONTREG9), 8), '|9900'+ '|' +'E990'+ '|' +'1'+ '|', @P_NRSEQARQMAG);

   /* TOTALIZAO DO BLOCO H001 */
   SET @V_CONTREG9 = ISNULL (@V_CONTREG9,0) + 1;
   INSERT INTO ARQMAGNETICO
     (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
   VALUES
     ('62'+RIGHT(REPLICATE('0', 8)+RTRIM(@V_CONTREG9), 8), '|9900'+ '|' +'H001'+ '|' +'1'+ '|', @P_NRSEQARQMAG);

   /* TOTALIZAO DO BLOCO H020 */
   SET @V_TOTREG = 0;
   SET @V_CONTREG9 = ISNULL(@V_CONTREG9,0) + 1;
   SELECT @V_TOTREG = COUNT(*)
   FROM ARQMAGNETICO
   WHERE SUBSTRING(DSREGARQMAG,2,4) = 'H020';

   IF @V_TOTREG IS NOT NULL BEGIN
      INSERT INTO ARQMAGNETICO
        (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
      VALUES
        ('62'+RIGHT(REPLICATE('0', 8)+RTRIM(@V_CONTREG9), 8), '|9900'+ '|' +'H020'+ '|' + CONVERT(VARCHAR, @V_TOTREG) + '|', @P_NRSEQARQMAG);
   END;

   /* TOTALIZAO DO BLOCO H025 */
   SET @V_TOTREG = 0;
   SET @V_CONTREG9 = ISNULL(@V_CONTREG9,0) + 1;
   SELECT @V_TOTREG = COUNT(*)
   FROM ARQMAGNETICO
   WHERE SUBSTRING(DSREGARQMAG,2,4) = 'H025';

   IF @V_TOTREG IS NOT NULL BEGIN
      INSERT INTO ARQMAGNETICO
        (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
      VALUES
        ('62'+RIGHT(REPLICATE('0',8)+RTRIM(@V_CONTREG9),8), '|9900'+ '|' +'H025'+ '|' + CONVERT(VARCHAR, @V_TOTREG) + '|',@P_NRSEQARQMAG);
   END;

   /* TOTALIZAO DO BLOCO H990 */
   SET @V_CONTREG9 = ISNULL(@V_CONTREG9,0) + 1;
   INSERT INTO ARQMAGNETICO
     (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
   VALUES
     ('62'+RIGHT(REPLICATE('0',8)+RTRIM(@V_CONTREG9),8), '|9900'+ '|' +'H990'+ '|' +'1'+ '|',@P_NRSEQARQMAG);

   /* TOTALIZAO DO BLOCO 8001 */
   SET @V_CONTREG9 = ISNULL(@V_CONTREG9,0) + 1;
   INSERT INTO ARQMAGNETICO
     (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
   VALUES
     ('62'+RIGHT(REPLICATE('0',8)+RTRIM(@V_CONTREG9),8), '|9900'+ '|' +'8001'+ '|' +'1'+ '|',@P_NRSEQARQMAG);

   /* TOTALIZAO DO BLOCO 8990 */
   SET @V_CONTREG9 = ISNULL(@V_CONTREG9,0) + 1;
   INSERT INTO ARQMAGNETICO
     (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
   VALUES
     ('62'+RIGHT(REPLICATE('0',8)+RTRIM(@V_CONTREG9),8), '|9900'+ '|' +'8990'+ '|' +'1'+ '|',@P_NRSEQARQMAG);

   /* TOTALIZAO DO BLOCO 9001 */
   SET @V_CONTREG9 = ISNULL(@V_CONTREG9,0) + 1;
   INSERT INTO ARQMAGNETICO
     (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
   VALUES
     ('62'+RIGHT(REPLICATE('0',8)+RTRIM(@V_CONTREG9),8), '|9900'+ '|' +'9001'+ '|' +'1'+ '|',@P_NRSEQARQMAG);

   /* TOTALIZAO DO BLOCO 9900 */
   SET @V_TOTREG = 0;
   SET @V_CONTREG9 = ISNULL(@V_CONTREG9,0) + 1;
   SELECT @V_TOTREG = COUNT(*)
   FROM ARQMAGNETICO
   WHERE SUBSTRING(DSREGARQMAG,2,4) = '9900';

   IF @V_TOTREG IS NOT NULL BEGIN
      SET @V_TOTREG = ISNULL(@V_TOTREG,0) + 3;  /*CONTA OS REGISTROS RESTANTES (9900, 9990, 9999) */
      INSERT INTO ARQMAGNETICO
        (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
      VALUES
        ('62'+RIGHT(REPLICATE('0',8)+RTRIM(@V_CONTREG9),8), '|9900'+ '|' +'9900'+ '|' + CONVERT(VARCHAR,@V_TOTREG) + '|',@P_NRSEQARQMAG);
   END;

   /* TOTALIZAO DO BLOCO 9990 */
   SET @V_CONTREG9 = ISNULL(@V_CONTREG9,0) + 2;
   INSERT INTO ARQMAGNETICO
     (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
   VALUES
     ('62'+RIGHT(REPLICATE('0',8)+RTRIM(@V_CONTREG9),8), '|9900'+ '|' +'9990'+ '|' +'1'+ '|',@P_NRSEQARQMAG);

   /* ABERTURA DO BLOCO 9 */
   IF @V_CONTREG9 <> 0 BEGIN
      SET @V_MOVIMENT = 0;
   END
   ELSE BEGIN
      SET @V_MOVIMENT = 1;
   END;

   SET @V_CONTREG9 = ISNULL(@V_CONTREG9,0) + 1;
   INSERT INTO ARQMAGNETICO
     (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
   VALUES
     ('60'+RIGHT(REPLICATE('0',8)+RTRIM(@V_CONTREG9),8), '|9001'+ '|' + CONVERT(VARCHAR, @V_MOVIMENT) + '|' ,@P_NRSEQARQMAG);

   /* ENCERRAMENTO DO BLOCO 9 */
   SET @V_CONTREG9 = ISNULL(@V_CONTREG9,0) + 1;
   INSERT INTO ARQMAGNETICO
     (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
   VALUES
     ('63'+RIGHT(REPLICATE('0',8)+RTRIM(@V_CONTREG9),8), '|9990'+ '|' + CONVERT(VARCHAR,@V_CONTREG9) + '|',@P_NRSEQARQMAG);

   SET @P_RETURN = @V_CONTREG9;
END
GO

-- VERSAO --
EXEC ATUVEROBJ 'ARQDIGITAL_BLOCO9','5.05.008';
GO

