IF EXISTS (SELECT *
             FROM SYSOBJECTS O, SYSUSERS U
            WHERE O.NAME = 'ETL_PEDIDOS'
              AND TYPE   = 'P'
	           AND U.UID  = O.UID
	           AND U.NAME = USER
          )
	  DROP PROCEDURE ETL_PEDIDOS
GO
CREATE PROCEDURE ETL_PEDIDOS( @P_DTINI  DATETIME,
                              @P_DTFINA DATETIME)

AS
   DECLARE @V_MES           VARCHAR(2);
   DECLARE @V_ANO           VARCHAR(4);
   DECLARE @V_CDSEGMER      VARCHAR(5);
   DECLARE @V_DT            VARCHAR(10);
   DECLARE @V_MAIOR         VARCHAR(2);

   DECLARE @V_VRIMPOSTO     DOUBLE PRECISION;
   DECLARE @V_PRECOBASE     DOUBLE PRECISION;
   DECLARE @V_VRTIPOCUSTO1  DOUBLE PRECISION;
   DECLARE @V_VRTIPOCUSTO2  DOUBLE PRECISION;
   DECLARE @V_VRTIPOCUSTO3  DOUBLE PRECISION;
   DECLARE @V_MEDDIA        DOUBLE PRECISION;
   DECLARE @V_DIASSEMPED    DOUBLE PRECISION;

   DECLARE @V_NRTIPOCUSTO1  NUMERIC;
   DECLARE @V_NRTIPOCUSTO2  NUMERIC;
   DECLARE @V_NRTIPOCUSTO3  NUMERIC;
   DECLARE @V_NRDIA         NUMERIC;
   DECLARE @V_QTPEDIDO      NUMERIC;
   DECLARE @V_QTREG         NUMERIC;

   DECLARE @V_NMTIPOCUSTO1  VARCHAR(50);
   DECLARE @V_NMTIPOCUSTO2  VARCHAR(50);
   DECLARE @V_NMTIPOCUSTO3  VARCHAR(50);
   DECLARE @V_SITPED        VARCHAR(30);
   DECLARE @V_TIPPED        VARCHAR(30);
   DECLARE @V_GRUPCLIE      VARCHAR(10);

  ----------------CURSOR C_PRECUSTO-----------------
   DECLARE @V_NRTIPOCUSTO   NUMERIC;
   DECLARE @V_NMTIPOCUSTO   VARCHAR(50);
  --------------------------------------------------

  ----------------CURSOR DE PEDIDO E DIA------------------
   DECLARE @V_CDCLIENTE     VARCHAR(21);
   DECLARE @V_CDFILIAL      VARCHAR(4);
   DECLARE @V_DTPEDIDO      DATETIME;
   DECLARE @V_NRPEDIDO      VARCHAR(10);
   DECLARE @V_CDPRECOBASE   VARCHAR(2);
   DECLARE @V_IDSITPEDIDO   VARCHAR(1);
   DECLARE @V_IDTIPOPEDIDO  VARCHAR(1);
  --------------------------------------------------------

  -----------------CURSOR DE ITEM-------------------
   DECLARE @V_CDPRODUTO     VARCHAR(10);
   DECLARE @V_VRPREUNITPED  DOUBLE PRECISION;
   DECLARE @V_CDOPERADOR    VARCHAR(12);
   DECLARE @V_QTITEMPED     DOUBLE PRECISION;
   DECLARE @V_NRITEMPED     VARCHAR(10);
  --------------------------------------------------

  -----------------CURSOR DATA DO PEDIDO-------------------
   DECLARE @V_NRETLPEDIDO   VARCHAR(10);
   DECLARE @V_CDCLIENTEETL  VARCHAR(21);
   DECLARE @V_DATAPED       DATETIME;
  ---------------------------------------------------------

   DECLARE @V_DTINI         DATETIME;
   DECLARE @V_DTFINA        DATETIME;
   DECLARE @V_DTPEDFIM      DATETIME;
   DECLARE @V_DTPED         DATETIME;
BEGIN

   SET @V_MES = CONVERT(VARCHAR, MONTH(@P_DTINI));
   SET @V_ANO = CONVERT(VARCHAR, YEAR(@P_DTINI));
   SET @V_DTINI = CONVERT(DATETIME,('01/'+@V_MES+'/'+@V_ANO),103);

   BEGIN TRANSACTION
     DELETE FROM ETLPEDIDO
     WHERE CDANOBI > @V_ANO
        OR (CDANOBI = @V_ANO AND CDMESBI >= @V_MES);
   COMMIT TRANSACTION;

   BEGIN TRANSACTION
     DELETE FROM ETLDIASEMPED
     WHERE CDANOBI > @V_ANO
        OR (CDANOBI = @V_ANO AND CDMESBI >= @V_MES);
   COMMIT TRANSACTION;

   DECLARE C_PRECUSTO CURSOR FOR --> Seleciona 3 tipos de custo parametrizados
   (
      SELECT (CONVERT(DOUBLE PRECISION, CDTIPOCUSTO)) AS NRTIPOCUSTO, NMTIPOCUSTO
        FROM TIPOCUSTO
       WHERE IDTPCUSTOGSC = 'S'
   );
   OPEN C_PRECUSTO;
   FETCH NEXT FROM C_PRECUSTO INTO
         @V_NRTIPOCUSTO, @V_NMTIPOCUSTO;
   WHILE(@@FETCH_STATUS = 0)BEGIN

      IF @V_NRTIPOCUSTO    = 1 BEGIN
         SET @V_NRTIPOCUSTO1    = @V_NRTIPOCUSTO;
         SET @V_NMTIPOCUSTO1    = @V_NMTIPOCUSTO;
      END;
      IF @V_NRTIPOCUSTO = 2 BEGIN
         SET @V_NRTIPOCUSTO2    = @V_NRTIPOCUSTO;
         SET @V_NMTIPOCUSTO2    = @V_NMTIPOCUSTO;
      END;
      IF @V_NRTIPOCUSTO = 3 BEGIN
         SET @V_NRTIPOCUSTO3    = @V_NRTIPOCUSTO;
         SET @V_NMTIPOCUSTO3    = @V_NMTIPOCUSTO;
      END;
      FETCH NEXT FROM C_ETL INTO
            @V_NRTIPOCUSTO, @V_NMTIPOCUSTO;
   END; /* FIM LOOP CURSOR C_PRECUSTO */
   CLOSE C_PRECUSTO;
   DEALLOCATE C_PRECUSTO;

   WHILE (@V_DTINI <= @P_DTFINA) BEGIN
      BEGIN TRANSACTION

      SET @V_DTFINA = DATEADD (MM,1,@V_DTINI) - DAY(@V_DTINI);

      DECLARE C_PED CURSOR FOR
      (
        SELECT CDCLIENTE, DTPEDIDO, CDFILIAL,
               NRPEDIDO, CDPRECOBASE, IDSITPEDIDO, IDTIPOPEDIDO
          FROM PEDIDO
         WHERE DTPEDIDO BETWEEN @V_DTINI AND @V_DTFINA
      );
      OPEN C_PED;
      FETCH NEXT FROM C_PED INTO
            @V_CDCLIENTE, @V_CDFILIAL, @V_DTPEDIDO,
            @V_NRPEDIDO, @V_CDPRECOBASE, @V_IDSITPEDIDO, @V_IDTIPOPEDIDO;
      WHILE(@@FETCH_STATUS = 0)BEGIN

         SELECT @V_CDSEGMER = CDSEGMER,
                @V_GRUPCLIE = CDGRUPCLIE
           FROM CLIENTE
          WHERE CDCLIENTE = @V_CDCLIENTE;

         DECLARE C_ITEM CURSOR FOR
         (
            SELECT CDPRODUTO, VRPREUNITPED,
                   CDOPERADOR, QTITEMPED,
                   NRITEMPED
              FROM ITEMPEDIDO
             WHERE NRPEDIDO = @V_NRPEDIDO
               AND CDFILIAL = @V_CDFILIAL
         );
         OPEN C_ITEM;
         FETCH NEXT FROM C_ITEM INTO
               @V_CDPRODUTO, @V_VRPREUNITPED, @V_CDOPERADOR,
               @V_QTITEMPED, @V_NRITEMPED;
         WHILE(@@FETCH_STATUS = 0)BEGIN

            SELECT @V_PRECOBASE = VRITEPREBASE
              FROM ITEMPREBASE
             WHERE CDPRODUTO = @V_CDPRODUTO
               AND CDPRECOBASE = @V_CDPRECOBASE;

            SELECT @V_VRIMPOSTO = SUM(VRIMPOSTOITPED)
              FROM IMPITEMPEDIDO
             WHERE NRPEDIDO = @V_NRPEDIDO
               AND NRITEMPED = @V_NRITEMPED;

            SET @V_VRTIPOCUSTO1 = TEKNISA.CUSTO_PRODUTO(@V_CDFILIAL, @V_CDPRODUTO, @V_NRTIPOCUSTO1, @V_DTPEDIDO, GETDATE());
            SET @V_VRTIPOCUSTO2 = TEKNISA.CUSTO_PRODUTO(@V_CDFILIAL, @V_CDPRODUTO, @V_NRTIPOCUSTO2, @V_DTPEDIDO, GETDATE());
            SET @V_VRTIPOCUSTO3 = TEKNISA.CUSTO_PRODUTO(@V_CDFILIAL, @V_CDPRODUTO, @V_NRTIPOCUSTO3, @V_DTPEDIDO, GETDATE());

            SET @V_DT = CONVERT(VARCHAR, @V_DTPEDIDO, 103);

            IF @V_IDSITPEDIDO = '1' BEGIN
               SET @V_SITPED = 'Pendente';
            END
            ELSE BEGIN
               IF @V_IDSITPEDIDO = '2' BEGIN
                  SET @V_SITPED = 'Em Andamento';
               END
               ELSE BEGIN
                  IF @V_IDSITPEDIDO = '3' BEGIN
                     SET @V_SITPED = 'Liquidado';
                  END
                  ELSE BEGIN
                     IF @V_IDSITPEDIDO = '4' BEGIN
                        SET @V_SITPED = 'Cancelado';
                     END
                     ELSE BEGIN
                        IF @V_IDSITPEDIDO = '5' BEGIN
                           SET @V_SITPED = 'Liquidao Forada';
                        END
                        ELSE BEGIN
                           SET @V_SITPED = 'Parcialmente Aberto';
                        END;
                     END;
                  END;
               END;
            END;

            IF @V_IDTIPOPEDIDO = '1' BEGIN
               SET @V_TIPPED = 'Pedido';
            END
            ELSE BEGIN
               SET @V_TIPPED = 'Oramento';
            END;

            INSERT INTO ETLPEDIDO
            (
              NRETLPEDIDO      , CDCLIENTE     , CDFILIAL       ,
              CDOPERADOR       , CDPRODUTO     , QTITEMETLPED   ,
              CDMESBI          , CDANOBI       , CDSEGMER       ,
              VRPREUNITETLPED  , VRPRECOBASE   , VRIMPOSTOPED   ,
              VRCUS1           , VRCUS2        , VRCUS3         ,
              DTETLPEDIDO      , DSSITPEDETLPED, DSTIPOPEDETLPED, CDGRUPCLIE
            )
            VALUES
            (
              @V_NRPEDIDO        , @V_CDCLIENTE        , @V_CDFILIAL         ,
              @V_CDOPERADOR      , @V_CDPRODUTO        , @V_QTITEMPED        ,
              @V_MES             , @V_ANO              , @V_CDSEGMER         ,
              @V_VRPREUNITPED    , @V_PRECOBASE        , @V_VRIMPOSTO        ,
              @V_VRTIPOCUSTO1    , @V_VRTIPOCUSTO2     , @V_VRTIPOCUSTO3     ,
              @V_DT              , @V_SITPED           , @V_TIPPED, @V_GRUPCLIE
            );

            FETCH NEXT FROM C_ITEM INTO
                  @V_CDPRODUTO, @V_VRPREUNITPED, @V_CDOPERADOR,
                  @V_QTITEMPED, @V_NRITEMPED;

         END; /*FIM LOOP PEDIDO*/
         CLOSE C_ITEM;
         DEALLOCATE C_ITEM;

         FETCH NEXT FROM C_PED INTO
               @V_CDCLIENTE, @V_CDFILIAL, @V_DTPEDIDO,
               @V_NRPEDIDO, @V_CDPRECOBASE, @V_IDSITPEDIDO, @V_IDTIPOPEDIDO;

      END; /*FIM LOOP PEDIDO*/
      CLOSE C_PED;
      DEALLOCATE C_PED;

      COMMIT TRANSACTION;

      SET @V_DTINI = DATEADD(MM, 1, @V_DTINI);
      SET @V_MES = CONVERT(VARCHAR, MONTH(@V_DTINI));
      SET @V_ANO = CONVERT(VARCHAR, YEAR(@V_DTINI));
   END; /*FIM LOOP WHILE*/

   DECLARE C_DIA CURSOR FOR
   (
     SELECT DISTINCT(CDCLIENTE) AS CDCLIENTE, CDFILIAL
         FROM ETLPEDIDO
   );
   OPEN C_DIA;
   FETCH NEXT FROM C_DIA INTO
         @V_CDCLIENTE, @V_CDFILIAL;
   WHILE(@@FETCH_STATUS = 0)BEGIN

      SELECT @V_DTPEDFIM = MAX(CONVERT(DATETIME, DTETLPEDIDO,103))
        FROM ETLPEDIDO
       WHERE CDCLIENTE = @V_CDCLIENTE
         AND CDFILIAL = @V_CDFILIAL;

      SET @V_DTPED = NULL;
      SET @V_QTPEDIDO = 0;
      SET @V_DIASSEMPED = 0;
      DECLARE C_DTPED CURSOR FOR
      (
         SELECT DISTINCT CONVERT(DATETIME, DTETLPEDIDO, 103) AS DATAPED,
                NRETLPEDIDO, CDCLIENTE
           FROM ETLPEDIDO
          WHERE CDCLIENTE = @V_CDCLIENTE
            AND CDFILIAL = @V_CDFILIAL
      );
      OPEN C_DTPED;
      FETCH NEXT FROM C_DTPED INTO
            @V_NRETLPEDIDO, @V_CDCLIENTEETL,
            @V_DATAPED;
      WHILE(@@FETCH_STATUS = 0)BEGIN

         IF (@V_DTPED IS NOT NULL) AND
            (@V_DTPED <> @V_DATAPED) BEGIN
            SET @V_DIASSEMPED = @V_DIASSEMPED + DATEDIFF(DAY, @V_DTPED, @V_DATAPED);
         END;

         SET @V_QTPEDIDO = @V_QTPEDIDO + 1;
         SET @V_DTPED = @V_DATAPED;
         SET @V_NRPEDIDO = @V_NRETLPEDIDO;

         FETCH NEXT FROM C_DTPED INTO
               @V_NRETLPEDIDO, @V_CDCLIENTEETL,
               @V_DATAPED;
      END;
      CLOSE C_DTPED;
      DEALLOCATE C_DTPED;

      SET @V_QTPEDIDO = @V_QTPEDIDO - 1; /* Subtrai uma unidade porque ele deve considerar apenas o intervalo entre os pedidos e no a quantidade de pedidos */

      IF @V_QTPEDIDO <= 1 BEGIN
         SET @V_MEDDIA = 0;
      END
      ELSE BEGIN
         SET @V_MEDDIA = ROUND(@V_DIASSEMPED /@V_QTPEDIDO, 0, 1);
      END;

      SET @V_NRDIA = (CONVERT(DOUBLE PRECISION, GETDATE()) - CONVERT(DOUBLE PRECISION, @V_DTPEDFIM)) ;
      SET @V_DT = CONVERT(DATETIME,@V_DTPEDFIM,103);
      SET @V_MES = CONVERT(VARCHAR, MONTH(@V_DTPEDFIM));
      SET @V_ANO = CONVERT(VARCHAR, YEAR(@V_DTPEDFIM));

      /* A ETLDIASEMPED diferencia os valores do cliente por Situao do Pedido (SITPEDIDO) e
         Tipo de Pedido (TIPOPEDIDO). Desta forma ele duplica os registros para o mesmo cliente.
         Os mesmos valores mdia e nmero de dias so gravados nestes registros e o sistema soma
         os valores no DW, somando o mesmo valore vrias vezes.

         A rotina deve ratear os valores entre os registros, para que o sistema apresente o
         valor correto.
      */
      SELECT @V_QTREG = COUNT(*)
        FROM (SELECT DISTINCT CDCLIENTE, CDFILIAL, DSSITPEDETLPED, DSTIPOPEDETLPED, CDGRUPCLIE
               FROM ETLPEDIDO
              WHERE CDCLIENTE = @V_CDCLIENTE
                AND CDFILIAL = @V_CDFILIAL) AA;

      IF @V_QTREG > 0 BEGIN
         SET @V_MEDDIA = @V_MEDDIA / @V_QTREG;
         SET @V_NRDIA = @V_NRDIA / @V_QTREG;
      END;

      INSERT INTO ETLDIASEMPED
      (
         CDCLIENTE          , CDFILIAL           , NRMEDIADIAPED    ,
         NRDIASEMPED        , NRULTIMOPEDIDO     , CDMESBI          ,
         CDANOBI            , DTDIASEMPEDIDO
      )
      VALUES
      (
         @V_CDCLIENTE , @V_CDFILIAL , @V_MEDDIA ,
         @V_NRDIA     , @V_NRPEDIDO , @V_MES    ,
         @V_ANO       , @V_DT
      );
      COMMIT;

      FETCH NEXT FROM C_DIA INTO
            @V_CDCLIENTE, @V_CDFILIAL;
   END;
   CLOSE C_DIA;
   DEALLOCATE C_DIA;
   COMMIT TRANSACTION;
END;
GO

/*REGISTRANDO A PROCEDURE PARA O AGENDADOR DE EVENTOS*/
DECLARE @V_CDSEQUENCIAL VARCHAR(20);
BEGIN
   SELECT @V_CDSEQUENCIAL = COUNT(*)
   FROM   EVENTOAEV 
   WHERE  NMOBJBDEVEN = 'ETL_PEDIDOS';
    
   IF @V_CDSEQUENCIAL = 0 BEGIN   --> S ADICIONA A PROCEDURE SE ELA NO EXISTIR AINDA NO CADASTRO
      BEGIN TRAN;

         SELECT @V_CDSEQUENCIAL = RIGHT(REPLICATE('0', 10) + ISNULL(MAX(CDEVENTOAEV)+1,0), 10)
         FROM   EVENTOAEV;
        
         INSERT INTO EVENTOAEV 
            (CDEVENTOAEV, NMEVENTOAEV, IDTPEVENAEV, CDOPERINCL, DTINCLEVEN, NMOBJBDEVEN)
         VALUES
            (@V_CDSEQUENCIAL,'ETL Pedidos','STP',NULL,GETDATE(),'ETL_PEDIDOS');

         INSERT INTO PARAMEVENTO
            (CDEVENTOAEV,NMPARAMEVEN,IDDADPARAMEVEN,IDTIPPARAMEVEN,DSPARAMEVEN,IDPARAMNULL,VRTAMPARAM,NRSEQPARAMEVEN) 
         VALUES
            (@V_CDSEQUENCIAL,'P_DTINI','D','E','Data Inicial','N',0,'01');

         INSERT INTO PARAMEVENTO
            (CDEVENTOAEV,NMPARAMEVEN,IDDADPARAMEVEN,IDTIPPARAMEVEN,DSPARAMEVEN,IDPARAMNULL,VRTAMPARAM,NRSEQPARAMEVEN) 
         VALUES
            (@V_CDSEQUENCIAL,'P_DTFINA','D','E','Data Final','N',0,'02');

      COMMIT TRAN;

      IF @@ERROR <> 0 BEGIN
         ROLLBACK TRAN;
         PRINT 'Falha no cadastro de eventos agendveis.';
      END;
   END;
END;

GO

BEGIN

   INSERT INTO TABELADW (CDTABELADW, NMTABELADW, IDDRILLDOWN) VALUES ('ETLPEDIDO','Pedidos','N');

   EXEC CRIA_FATOS 'ETLPEDIDO', 'VRPREUNITETLPED',   'Preo vendido',  'Pedido';
   EXEC CRIA_FATOS 'ETLPEDIDO', 'VRPRECOBASE',       'Preo base',  'Pedido';
   EXEC CRIA_FATOS 'ETLPEDIDO', 'VRIMPOSTOPED',      'Imposto',  'Pedido';
   EXEC CRIA_FATOS 'ETLPEDIDO', 'VRCUS1',            'Custo Mdio liq.',  'Pedido';
   EXEC CRIA_FATOS 'ETLPEDIDO', 'VRCUS2',            'Custo Mdio bru.',  'Pedido';
   EXEC CRIA_FATOS 'ETLPEDIDO', 'VRCUS3',            'Custo Mdio liq. epoca',  'Pedido';
   EXEC CRIA_FATOS 'ETLPEDIDO', 'QTITEMETLPED',      'Qtd. vendida',  'Pedido';

   EXEC CRIA_DIME 'ETLPEDIDO',  'CDFILIAL',   'Filial',          'FILIAL',   'CDFILIAL',   'NMFILIAL',   NULL;
   EXEC CRIA_DIME 'ETLPEDIDO',  'CDCLIENTE',  'Cliente',         'CLIENTE',  'CDCLIENTE',  'NMFANTCLIE',  NULL;
   EXEC CRIA_DIME 'ETLPEDIDO',	'CDOPERADOR', 'Operador',	 'OPERADOR', 'CDOPERADOR', 'NMOPERADOR', NULL;
   EXEC CRIA_DIME 'ETLPEDIDO',	'CDPRODUTO',  'Produto',	 'PRODUTO',  'CDPRODUTO',  'NMPRODUTO',	 NULL;
   EXEC CRIA_DIME 'ETLPEDIDO',  'DTETLPEDIDO','Data do Pedido',   NULL,       NULL,         NULL,         NULL;
   EXEC CRIA_DIME 'ETLPEDIDO',  'NRETLPEDIDO','N do Pedido.',   NULL,       NULL,         NULL,         NULL;
   EXEC CRIA_DIME 'ETLPEDIDO',  'CDSEGMER',   'Segmento de Mercado',  'SEGMERCADO',   'CDSEGMER',  'DSSEGMER',         NULL;
   EXEC CRIA_DIME 'ETLPEDIDO',  'CDANOBI',    'Ano',             'ETLANOBI', 'CDANOBI',    'NMANOBI',    NULL;
   EXEC CRIA_DIME 'ETLPEDIDO',  'CDMESBI',    'Ms',  	         'ETLMESBI', 'CDMESBI',    'NMMESBI',    NULL;


   INSERT INTO TABELADW (CDTABELADW, NMTABELADW, IDDRILLDOWN) VALUES ('ETLDIASEMPED','Dias sem Pedido','N');

   EXEC CRIA_FATOS 'ETLDIASEMPED', 'NRMEDIADIAPED',   'Mdia de dias',  'Pedido';
   EXEC CRIA_FATOS 'ETLDIASEMPED', 'NRDIASEMPED',     'N Dias sem contato',  'Pedido';

   EXEC CRIA_DIME 'ETLDIASEMPED',  'CDFILIAL',   'Filial',          'FILIAL',   'CDFILIAL',   'NMFILIAL',   NULL;
   EXEC CRIA_DIME 'ETLDIASEMPED',  'CDCLIENTE',  'Cliente',         'CLIENTE',  'CDCLIENTE',  'NMFANTCLIE',  NULL;
   EXEC CRIA_DIME 'ETLDIASEMPED',  'DTDIASEMPEDIDO','Data do Pedido.',   NULL,       NULL,         NULL,         NULL;
   EXEC CRIA_DIME 'ETLDIASEMPED',  'NRULTIMOPEDIDO','N do Pedido.',   NULL,       NULL,         NULL,         NULL;
   EXEC CRIA_DIME 'ETLDIASEMPED',  'CDANOBI',    'Ano',             'ETLANOBI', 'CDANOBI',    'NMANOBI',    NULL;
   EXEC CRIA_DIME 'ETLDIASEMPED',  'CDMESBI',    'Ms',  	         'ETLMESBI', 'CDMESBI',    'NMMESBI',    NULL;
END;
GO


-- VERSAO --
EXEC ATUVEROBJ 'ETL_PEDIDOS','0.00.000';
GO